/***************************************/
//         Highscore Functions         //
/***************************************/

#include "CompileOpts.h"      // Compiler Options
#include <tigcclib.h>         // Library Header Files
#include "Defines.h"          // Numerical Constants
#include "Typedefs.h"         // Custom Defined Types
#include "Prototypes.h"       // Function Prototypes
#include "extgraph.h"         // Graphics Routines
#include "Globals.h"          // Global Variables



void high_score (void)
{
unsigned char * name_list = hscr_ptr+HSNAMES_OFFSET+((game_type-1)*(HSNAMES_T_OFFSET-HSNAMES_OFFSET));
unsigned long int * score_list = (unsigned long int *)((unsigned char *)hscr_ptr+HSSCORES_OFFSET+((game_type-1)*(HSSCORES_T_OFFSET-HSSCORES_OFFSET)));
unsigned short int a,b,place=6;
unsigned char * temp_name;
unsigned long int temp_score;

//draw rectangles
DrawGrayRect2B(14 , 5 , 132 , 91 , COLOR_BLACK , RECT_FILLED, LCD_MEM , LCD_MEM);
DrawGrayRect2B(15 , 20 , 130 , 89 , COLOR_WHITE , RECT_FILLED , LCD_MEM , LCD_MEM);
//draw title bar
FontSetSys(F_6x8);
DrawStr(43 , 10 , "HIGHSCORES" , A_REVERSE);
//draw scores
for (a=0; a<6; a++)
	{
	temp_score = *(score_list+a);
	temp_name = name_list+(9*a);
	if ((score > temp_score)&&(place==6))//if you made a highscore
		{
		place = a;
		for (b=5; b>place; b--)
			{//swap 9 chars and one long for each name
			*(name_list+b*9)=*(name_list+b*9-9);
			*(name_list+b*9+1)=*(name_list+b*9-8);
			*(name_list+b*9+2)=*(name_list+b*9-7);
			*(name_list+b*9+3)=*(name_list+b*9-6);
			*(name_list+b*9+4)=*(name_list+b*9-5);
			*(name_list+b*9+5)=*(name_list+b*9-4);
			*(name_list+b*9+6)=*(name_list+b*9-3);
			*(name_list+b*9+7)=*(name_list+b*9-2);
			*(name_list+b*9+8)=*(name_list+b*9-1);

			*(score_list+b)=*(score_list+b-1);
			}
		*(score_list+place)=score;
		for (b=0; b<9; b++)
			{
			*(name_list+place*9+b)=0;
			}
		temp_score=score;
		}

	DrawStr(51-(DrawStrWidth(temp_name,F_6x8)>>1),26+10*a,temp_name,A_NORMAL);
	if (game_type==PLAY_CLASSIC)
		{
		for (b=0; b<6; b++)
			{
			DrawChar(112-6*b,26+10*a,(temp_score%10)+'0',A_NORMAL);
			temp_score /= 10;
			}
		}
	else
		{
		DrawChar(94 , 26+10*a, ((temp_score/60) % 10) + '0' , A_NORMAL);
		DrawChar(88 , 26+10*a, ((temp_score/600) % 10) + '0' , A_NORMAL);
		DrawChar(82 , 26+10*a, ((temp_score/6000) % 10) + '0' , A_NORMAL);

		DrawChar(100 , 26+10*a, ':' , A_NORMAL);

		DrawChar(112 , 26+10*a, (temp_score % 10) + '0' , A_NORMAL);
		DrawChar(106 , 26+10*a, ((temp_score % 60) / 10) + '0' , A_NORMAL);
		}
	}
//input name
if (place<6)
	{
	wait(MENU_WAIT);
	input_str(name_list+place*9,place);
	DrawGrayRect2B(26 , 24+10*place , 76 , 34+10*place , COLOR_WHITE , RECT_FILLED , LCD_MEM , LCD_MEM);
	DrawStr(51-(DrawStrWidth(name_list+place*9,F_6x8)>>1),26+10*place,name_list+place*9,A_NORMAL);
	}


wait(MENU_WAIT);
while (!(_keytest(RR_ENTER) || _keytest(RR_2ND) || _keytest(RR_ESC)))
	idle();
}



void input_str(unsigned char *buffer, unsigned short int place)
{
void *kbq = kbd_queue();
unsigned short int key, i=0;

SetIntVec(AUTO_INT_1,save_ai1);

DrawGrayRect2B(26 , 24+10*place , 76 , 34+10*place , COLOR_BLACK , RECT_FILLED , LCD_MEM , LCD_MEM);
DrawGrayRect2B(27 , 25+10*place , 75 , 33+10*place , COLOR_WHITE , RECT_FILLED , LCD_MEM , LCD_MEM);

while (TRUE)
	{
	if (!OSdequeue(&key,kbq))
		{
		if (((key==KEY_ENTER) || (key==KEY_ESC)) && (i))
			{
			SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
			return;
			}
		if (key >= ' ' && key <= '~' && i!=8)
			buffer[i++]=key;
		else if (key==KEY_BACKSPACE && i)
			i--;
		buffer[i]=0;
		DrawGrayRect2B(27 , 25+10*place , 75 , 33+10*place , COLOR_WHITE , RECT_FILLED , LCD_MEM , LCD_MEM);
		DrawStr(51-(DrawStrWidth(buffer,F_6x8)>>1),26+10*place,buffer,A_NORMAL);
		}
	}
}





