/***************************************/
//         Main Menu Functions         //
/***************************************/

#include "CompileOpts.h"      // Compiler Options
#include <tigcclib.h>         // Library Header Files
#include "Defines.h"          // Numerical Constants
#include "Typedefs.h"         // Custom Defined Types
#include "Prototypes.h"       // Function Prototypes
#include "extgraph.h"         // Graphics Routines
#include "Globals.h"          // Global Variables



BOOL menu (void)
{
unsigned short int a,b,counter=8000,msg_count=2;
unsigned short int offset[4] = {32,32,57,61};
const unsigned char * message[4] = {"MarkPeretich@hotmail.com","MarkPeretich@hotmail.com","Enter to Play","Esc to Quit"};
unsigned char * name_list = (unsigned char *)(hscr_ptr)+HSNAMES_OFFSET;
unsigned char * temp_name;
unsigned long int * score_list = (unsigned long int *)((unsigned char *)(name_list)+(HSSCORES_OFFSET-HSNAMES_OFFSET));
unsigned long int temp_score;
BOOL needs_drawn = TRUE;

wait(MENU_WAIT);
ClrScr();

SpriteX8_OR(0,4,92,((unsigned char *)(lvls_ptr)+INTROPIC_OFFSET),20,LCD_MEM);

FontSetSys(F_4x6);
DrawStr(offset[2],44,message[2],A_NORMAL);
while (!(_keytest(RR_ENTER) || _keytest(RR_2ND) || _keytest(RR_ESC)))
	{
	if (needs_drawn)
		{
		DrawGrayRect2B(28,30,132,39,COLOR_WHITE,RECT_FILLED,LCD_MEM,LCD_MEM); //Clear Title Sprite Area
		SpriteX8_OR(28,30,10,((unsigned char *)(lvls_ptr)+TITLESP_OFFSET+((game_type-1)*SIZE_OF_TITLESP)),13,LCD_MEM); //Draw Title Sprite
		DrawGrayRect2B(35,64,125,92,COLOR_WHITE,RECT_FILLED,LCD_MEM,LCD_MEM);//Clear High Score Box
		FontSetSys(F_6x8);
		for (a=0; a<3; a++)
			{
			temp_score = *((unsigned long int *)((unsigned char *)score_list+((game_type-1)*(HSSCORES_T_OFFSET-HSSCORES_OFFSET))+a*4));
			temp_name = name_list+(game_type-1)*HSNAMES_T_OFFSET+(9*a);
		
			DrawStr(59-(DrawStrWidth(temp_name,F_6x8)>>1),65+10*a,temp_name,A_NORMAL);
			
			if (game_type==PLAY_CLASSIC)
				{
				for (b=0; b<6; b++)
					{
					DrawChar(119-6*b,65+10*a,(temp_score%10)+'0',A_NORMAL);
					temp_score /= 10;
					}
				}
			else
				{
				DrawChar(101 , 65+10*a, ((temp_score/60) % 10) + '0' , A_NORMAL);
				DrawChar(95 , 65+10*a, ((temp_score/600) % 10) + '0' , A_NORMAL);
				DrawChar(89 , 65+10*a, ((temp_score/6000) % 10) + '0' , A_NORMAL);
			
				DrawChar(107 , 65+10*a, ':' , A_NORMAL);

				DrawChar(119 , 65+10*a, (temp_score % 10) + '0' , A_NORMAL);
				DrawChar(113 , 65+10*a, ((temp_score % 60) / 10) + '0' , A_NORMAL);
				}
			}
		needs_drawn = FALSE;
		FontSetSys(F_4x6);
		}
	if (!(--counter))
		{
		if (++msg_count==4) msg_count = 0;
		if (msg_count!=1) DrawGrayRect2B(32,44,127,49,COLOR_WHITE,RECT_FILLED,LCD_MEM,LCD_MEM);
		DrawStr(offset[msg_count],44,message[msg_count],A_NORMAL);
		counter = 8000;
		}
	if (_rowread(0xfffe)&((game_type-1)?2:8))
		{
		game_type = 3 - game_type;
		needs_drawn = TRUE;
		}
	}

if (_keytest(RR_ESC))
	return FALSE;

return TRUE;
}