/***************************************/
//       Object-Moving Functions       //
/***************************************/

#include "CompileOpts.h"      // Compiler Options
#include <tigcclib.h>         // Library Header Files
#include "Defines.h"          // Numerical Constants
#include "Typedefs.h"         // Custom Defined Types
#include "Prototypes.h"       // Function Prototypes
#include "extgraph.h"         // Graphics Routines
#include "Globals.h"          // Global Variables



void move_obj (OBJECT *object)
{
signed short int read, x_diff, y_diff, done, space_current,
		space_right, space_above, space_left, space_below;

//update tile vars
if (object->xshift==5)
	{
	object->xshift=0;
	object->x++;
	}
else if (object->xshift==-5)
	{
	object->xshift=0;
	object->x--;
	}
else if (object->yshift==4)
	{
	object->yshift=0;
	object->y++;
	}
else if (object->yshift==-4)
	{
	object->yshift=0;
	object->y--;
	}

//handle side to side warp
if (((object->x==0) && (object->direction==LEFT)) || ((object->x==28) && (object->direction==RIGHT)))
	{
	if (object->type != FRUIT_OBJECT)
		object->x = 28 - object->x;
	else
		kill_fruit();
	}

space_current = object->y*29+object->x,
space_right = space_current+1,
space_above = space_current-29,
space_left = space_current-1,
space_below = space_current+29;

//get last_dir_pressed var
if ((object->type == GHOST_OBJECT) && (!object->cage_delay))
	{
	if (hot_spots[space_current])
		{
		if (!random(DIFFICULTY))//random choice
			{
			done = FALSE;
			while (!done)
				{
				object->last_dir_pressed = random(4);
				if (((object->last_dir_pressed == UP)&&(level_data[space_above]<3)) || ((object->last_dir_pressed == RIGHT)&&(level_data[space_right]<3)) || ((object->last_dir_pressed == DOWN)&&(level_data[space_below]<3)) || ((object->last_dir_pressed == LEFT)&&(level_data[space_left]<3)))
					done = TRUE;
				else
					done = FALSE;
				}
			}
		else //intelligent choice
			{
			x_diff = EXT_SHORTABS(pacman.x - object->x);
			y_diff = EXT_SHORTABS(pacman.y - object->y);
			if (y_diff > x_diff)
				{
				if (pacman.y < object->y)
					object->last_dir_pressed = UP;
				else
					object->last_dir_pressed = DOWN;
				}
			else
				{
				if (pacman.x < object->x)
					object->last_dir_pressed = LEFT;
				else
					object->last_dir_pressed = RIGHT;
				}
			}
		}
	else
		{
		if (object->direction == RIGHT)
			{
			if (level_data[space_right]<3)
				object->last_dir_pressed = RIGHT;
			else if (level_data[space_above]<3)
				object->last_dir_pressed = UP;
			else if (level_data[space_below]<3)
				object->last_dir_pressed = DOWN;
			else
				object->last_dir_pressed = LEFT;
			}
		else if (object->direction == UP)
			{
			if (level_data[space_above]<3)
				object->last_dir_pressed = UP;
			else if (level_data[space_left]<3)
				object->last_dir_pressed = LEFT;
			else if (level_data[space_right]<3)
				object->last_dir_pressed = RIGHT;
			else
				object->last_dir_pressed = DOWN;
			}
		else if (object->direction == LEFT)
			{
			if (level_data[space_left]<3)
				object->last_dir_pressed = LEFT;
			else if (level_data[space_above]<3)
				object->last_dir_pressed = UP;
			else if (level_data[space_below]<3)
				object->last_dir_pressed = DOWN;
			else
				object->last_dir_pressed = RIGHT;
			}
		else //DOWN
			{
			if (level_data[space_below]<3)
				object->last_dir_pressed = DOWN;
			else if (level_data[space_left]<3)
				object->last_dir_pressed = LEFT;
			else if (level_data[space_right]<3)
				object->last_dir_pressed = RIGHT;
			else
				object->last_dir_pressed = UP;
			}
		}
	}
else if ((object->type == GHOST_OBJECT) && (object->cage_delay))//if ghost in cage
	{
	object->cage_delay--;

	if (object->cage_delay > 13)
		{
		object->last_dir_pressed = (object->cage_delay % 20 < 10)?RIGHT:LEFT;
		}
	else if (object->cage_delay == 13)
		{
		object->x = 14;
		object->y = 10;
		object->xshift = 0;
		object->yshift = 2;
		object->last_dir_pressed = UP;
		object->direction = UP;
		}
	else if (object->cage_delay && object->cage_delay < 13)
		{
		object->last_dir_pressed = UP;
		if (!object->cage_delay%2) // move slowly out of cage (1/2 speed)
			object->yshift++;
		}
	}
else if (!(object->type)) //else if (object->type == PACMAN_OBJECT)
	{
	read = _rowread(0xFFFE);
	if (read & 1)
		object->last_dir_pressed = UP;
	if (read & 2)
		object->last_dir_pressed = LEFT;
	if (read & 4)
		object->last_dir_pressed = DOWN;
	if (read & 8)
		object->last_dir_pressed = RIGHT;
	}
else if (object->type == FRUIT_OBJECT && object->is_on_screen)
	{
	if (hot_spots[space_current])
		{
		done = FALSE;
		while (!done)
			{
			object->last_dir_pressed = random(4);
			if (((object->last_dir_pressed == UP)&&(level_data[space_above]<3)) || ((object->last_dir_pressed == RIGHT)&&(level_data[space_right]<3)) || ((object->last_dir_pressed == DOWN)&&(level_data[space_below]<3)) || ((object->last_dir_pressed == LEFT)&&(level_data[space_left]<3)))
				done = TRUE;
			else
				done = FALSE;
			}
		}
	else
		{
		if (object->direction == RIGHT)
			{
			if (level_data[space_right]<3)
				object->last_dir_pressed = RIGHT;
			else if (level_data[space_above]<3)
				object->last_dir_pressed = UP;
			else if (level_data[space_below]<3)
				object->last_dir_pressed = DOWN;
			else
				object->last_dir_pressed = LEFT;
			}
		else if (object->direction == UP)
			{
			if (level_data[space_above]<3)
				object->last_dir_pressed = UP;
			else if (level_data[space_left]<3)
				object->last_dir_pressed = LEFT;
			else if (level_data[space_right]<3)
				object->last_dir_pressed = RIGHT;
			else
				object->last_dir_pressed = DOWN;
			}
		else if (object->direction == LEFT)
			{
			if (level_data[space_left]<3)
				object->last_dir_pressed = LEFT;
			else if (level_data[space_above]<3)
				object->last_dir_pressed = UP;
			else if (level_data[space_below]<3)
				object->last_dir_pressed = DOWN;
			else
				object->last_dir_pressed = RIGHT;
			}
		else //DOWN
			{
			if (level_data[space_below]<3)
				object->last_dir_pressed = DOWN;
			else if (level_data[space_left]<3)
				object->last_dir_pressed = LEFT;
			else if (level_data[space_right]<3)
				object->last_dir_pressed = RIGHT;
			else
				object->last_dir_pressed = UP;
			}
		}
	}

//make vulnerable ghosts run away, not chase
if ((object->type == GHOST_OBJECT) && (object->vulnerable) && (!object->cage_delay) && (hot_spots[space_current]))
	{
	if (object->last_dir_pressed == UP)
		object->last_dir_pressed = DOWN;
	if (object->last_dir_pressed == DOWN)
		object->last_dir_pressed = UP;
	if (object->last_dir_pressed == RIGHT)
		object->last_dir_pressed = LEFT;
	if (object->last_dir_pressed == LEFT)
		object->last_dir_pressed = RIGHT;
	}

//get real direction
if (!(object->xshift || object->yshift)) // if centered on a tile
	{
	if ((object->last_dir_pressed==UP) && (level_data[space_above]<3)) //up
		object->direction = UP;
	else if ((object->last_dir_pressed==LEFT) && (level_data[space_left]<3)) //left
		object->direction = LEFT;
	else if ((object->last_dir_pressed==DOWN) && (level_data[space_below]<3)) //down
		object->direction = DOWN;
	else if ((object->last_dir_pressed==RIGHT) && (level_data[space_right]<3)) //right
		object->direction = RIGHT;
	}

//set initial ghost direction after spawn
if ((object->type == GHOST_OBJECT) && (object->cage_delay == 1))
	object->direction = UP;

//move object
if ((object->direction == UP) && (level_data[space_above]<3))
	object->yshift--;
else if ((object->direction == LEFT) && (level_data[space_left]<3))
	object->xshift--;
else if ((object->direction == DOWN) && (level_data[space_below]<3))
	object->yshift++;
else if ((object->direction == RIGHT) && (level_data[space_right]<3))
	object->xshift++;

//decrement vulnerable ghost count
if ((object->type == GHOST_OBJECT) && (object->vulnerable))
	{
	object->vulnerable--;
	}
//animate pacman
if (!(object->type)) //quicker version of:  if (object->type == PACMAN_OBJECT)
	{
	object->ani_delay++;
	if (object->ani_delay == WAIT_FRAMES)
		object->ani_delay = 0;
	}
}



BOOL ghost_collide (void)
{
signed short int i;
for (i=0; i<4; i++)
	{
	if (BOUNDS_COLLIDE(pacman.x*5+pacman.xshift+1,pacman.y*4+pacman.yshift+1,ghost[i].x*5+ghost[i].xshift+1,ghost[i].y*4+ghost[i].yshift+1,3,2))
		{
		if (ghost[i].vulnerable)
			{
			if (game_type==PLAY_CLASSIC) score += 100 * (2 << pacman.ghosts_eaten); //200,400,800,1600 pts for each successive ghost
			pacman.ghosts_eaten++;
			draw_score();
			spawn_ghost(i);
			}
		else
			return TRUE;
		}
	}
return FALSE;
}



BOOL fruit_collide (void)
{
if (fruit.is_on_screen && BOUNDS_COLLIDE(pacman.x*5+pacman.xshift+1,pacman.y*4+pacman.yshift+1,fruit.x*5+fruit.xshift+1,fruit.y*4+fruit.yshift+1,3,2))
	{
	if (game_type==PLAY_CLASSIC) score += fruit.f_type * 400;
	else {limiting_factor-=(fruit.f_type*5); score+=(fruit.f_type*5);}

	if ((fruit.f_type == HEART)&&(lives<9))
		lives++;
	else if ((fruit.f_type == HEART)&&(lives==9))
		{
		if (game_type==PLAY_CLASSIC) score+=1600;
		else {limiting_factor-=10; score+=10;}
		}
	draw_score();
	return TRUE;
	}
return FALSE;
}